stages:
  - ci_image
  - build

deploy:
  image: docker:19.03.12
  stage: ci_image
  services:
    - name: docker:19.03.12-dind
      command: ["--experimental"]
  variables:
    BUILDX_VERSION: "v0.4.2"
  before_script:
    - apk add --update curl && rm -rf /var/cache/apk/*
    - curl -sSLo docker-buildx "https://github.com/docker/buildx/releases/download/$BUILDX_VERSION/buildx-$BUILDX_VERSION.linux-amd64"
    - chmod a+x docker-buildx
    - mkdir -p ~/.docker/cli-plugins
    - mv docker-buildx ~/.docker/cli-plugins/docker-buildx
    - docker buildx install
    - docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
    - docker login -u gitlab-ci-token -p "$CI_JOB_TOKEN" "$CI_REGISTRY"
    - docker buildx create --use --name mybuilder
  script:
    - docker buildx build --platform linux/arm64,linux/amd64 --push -t "$CI_REGISTRY_IMAGE:$CI_COMMIT_BRANCH" .

.build:
  image: "$CI_REGISTRY_IMAGE:$CI_COMMIT_BRANCH"
  stage: build
  variables:
    DISTRO: ""
    PLATFORM: ""
    DOCKER_HOST: tcp://docker:2375
  services:
    - docker:dind
  before_script:
    - docker run --rm --privileged aptman/qus -s -- -c -p
  script:
    - DISTRO=$DISTRO PLATFORM=$PLATFORM ./build.sh
  artifacts:
    paths:
      - "*.7z"

.icosa_build:
  extends: .build
  variables:
    PLATFORM: "icosa"
    HEKATE: "true"
    BOOT: "true"

.porg_build:
  extends: .build
  variables:
    PLATFORM: "porg"

.tx2_build:
  extends: .build
  variables:
    PLATFORM: "tx2"

.xavier_build:
  extends: .build
  variables:
    PLATFORM: "xavier"

arch:
  extends: .icosa_build
  variables:
    DISTRO: "arch"
blackarch:
  extends: .icosa_build
  variables:
    DISTRO: "blackarch"
bullseye:
  extends: .icosa_build
  variables:
    DISTRO: "bullseye"
fedora:
  extends: .icosa_build
  variables:
    DISTRO: "fedora"
focal:
  extends: .icosa_build
  variables:
    DISTRO: "focal"
hirsute:
  extends: .icosa_build
  variables:
    DISTRO: "hirsute"
leap:
  extends: .icosa_build
  variables:
    DISTRO: "leap"
tumbleweed:
  extends: .icosa_build
  variables:
    DISTRO: "tumbleweed"

arch:
  extends: .porg_build
  variables:
    DISTRO: "arch"
blackarch:
  extends: .porg_build
  variables:
    DISTRO: "blackarch"
bullseye:
  extends: .porg_build
  variables:
    DISTRO: "bullseye"
fedora:
  extends: .porg_build
  variables:
    DISTRO: "fedora"
focal:
  extends: .porg_build
  variables:
    DISTRO: "focal"
hirsute:
  extends: .porg_build
  variables:
    DISTRO: "hirsute"
leap:
  extends: .porg_build
  variables:
    DISTRO: "leap"
tumbleweed:
  extends: .porg_build
  variables:
    DISTRO: "tumbleweed"

arch:
  extends: .tx2_build
  variables:
    DISTRO: "arch"
blackarch:
  extends: .tx2_build
  variables:
    DISTRO: "blackarch"
bullseye:
  extends: .tx2_build
  variables:
    DISTRO: "bullseye"
fedora:
  extends: .tx2_build
  variables:
    DISTRO: "fedora"
focal:
  extends: .tx2_build
  variables:
    DISTRO: "focal"
hirsute:
  extends: .tx2_build
  variables:
    DISTRO: "hirsute"
leap:
  extends: .tx2_build
  variables:
    DISTRO: "leap"
tumbleweed:
  extends: .tx2_build
  variables:
    DISTRO: "tumbleweed"

arch:
  extends: .xavier_build
  variables:
    DISTRO: "arch"
blackarch:
  extends: .xavier_build
  variables:
    DISTRO: "blackarch"
bullseye:
  extends: .xavier_build
  variables:
    DISTRO: "bullseye"
fedora:
  extends: .xavier_build
  variables:
    DISTRO: "fedora"
focal:
  extends: .xavier_build
  variables:
    DISTRO: "focal"
hirsute:
  extends: .xavier_build
  variables:
    DISTRO: "hirsute"
leap:
  extends: .xavier_build
  variables:
    DISTRO: "leap"
tumbleweed:
  extends: .xavier_build
  variables:
    DISTRO: "tumbleweed"
